<button class="btn" [ngStyle]="{'margin': '10px'}" (click)="offForm()"
   [ngClass]="{'red': onForm, 'green': !onForm}">on/off form</button>
<div class="container " *ngIf="onForm">
   <form class="card" [formGroup]="form" (ngSubmit)="submit()">
      <h1>Angular Forms</h1>

      <div class="form-control">
         <label>Email</label>
         <input type="text" placeholder="Email" formControlName="email">


         <div class="validation" *ngIf="form.controls['email'].invalid && form.controls['email'].touched">
            <!-- *ngIf="form.invalid && (form.dirty || form.touched)"   один из способов рабочий -->
            <!-- ???   -->
            <div *ngIf="form.controls['email'].errors?.required"><small>поле email не может быть пустым</small></div>
            <div *ngIf="form.controls['email'].errors?.email">введите корректный email</div>
            <div *ngIf="form.controls['email'].errors?.restEmails">!!!!!заперещенный email</div>
            <div *ngIf="form.controls['email'].errors?.zanatEmail">{{form.controls['email'].value}} ZAniatOOOO</div>

            <!-- ??? -->
         </div>

      </div>



      <div class="form-control">
         <label>Пароль</label>
         <input type="password" placeholder="Пароль" formControlName="password">
         <div class="validation" *ngIf="form.controls['password'].invalid && form.controls['password'].touched">
            <div *ngIf="form.controls['password'].errors?.required">Пароль не может быть пустым</div>
            <div *ngIf="form.controls['password'].errors?.minlength">
               длинна должна быть не менее {{form.controls['password'].errors?.minlength.requiredLength}}
               сейчас количество символов :{{form.controls['password'].errors?.minlength.actualLength}}
            </div>
         </div>
      </div>


      <div class="card" formGroupName="address">
         <h2>Адрес</h2>

         <div class="form-control">
            <label>Страна</label>

            <select formControlName="country">
               <option value="ru">Россия</option>
               <option value="ua">Украина</option>
               <option value="by">Беларусь</option>
            </select>
         </div>

         <div class="form-control">
            <input type="text" formControlName="city" placeholder="Город">
         </div>

         <button class="btn" type="button" (click)="setCapital()">Выбрать столицу</button>
      </div>


      <!-- !есть решение через form builder !!! -->
      <div class="card" formGroupName="skills">
         <h2>Ваши навыки</h2>
         <button class="btn" type="button" (click)="addSkills()">Добавить умение</button>
         <div class="form-control" *ngFor="let control of skillControls; let idx = index">
            <label>умение {{idx + 1}}</label>
            <input type="text" [formControlName]="idx">
         </div>
      </div>

      <button class="btn" type="submit" [disabled]="form.invalid">Отправить</button>
   </form>
</div>
<app-reactive-forms></app-reactive-forms>
<app-http-client></app-http-client>